#include <stdio.h>
#include <stdlib.h>

#include <iostream>
using namespace std;

/*------------------------ DATA INPUT -------------------------*/

// vector input
void v_in( double *vector, int size )
{
  cout << "Vector Size: " << size << endl;

  cout << "Elements: ";
  for(int i=0; i<size; ++i)
    cout << " " << vector[i];
  cout << endl;
}

// matrix input
void m_in( double *matrix, int rows, int cols )
{
  cout << "Matrix Size: [" << rows << "," << cols << "]" << endl;

  for(int i=0; i<rows; ++i)
  {
    cout << "Row " << i+1 << ": ";
    for(int j=0; j<cols; ++j)
      cout << "\t" << matrix[i*cols+j];
    cout << endl;
  }
}

/*------------------------ DATA OUTPUT ------------------------*/

// vector output
void v_out( double **aout, int *size )
{
  // ATTENTION: this here is only for demonstrational purpose !
  // This data should be never destoyed, otherwise python will crash!
  // However, in some cases this is usefull ...

  int dsize = 8;
  double *data = new double[dsize];

  for(int i=0; i<dsize; ++i)
    data[i] = (i / 2.) + 3;

  *size = dsize;
  *aout = data;
}

// matrix output
void m_out(float **matrix, int *rows, int *cols)
{
  // ATTENTION: this here is only for demonstrational purpose !
  // This data should be never destoyed, otherwise python will crash!
  // However, in some cases this is usefull ...

  int drows = 2;
  int dcols = 3;
  float *data = new float[drows*dcols];

  for(int i=0; i<(drows*dcols); ++i)
    data[i] = (i / 2.) + 1;

  *rows = drows;
  *cols = dcols;
  *matrix = data;
}

/*------------------- DATA OUTPUT WITH COPY -------------------*/

// vector output
void v_out_copy( double **cpvector, int *cpsize )
{
  // ATTENTION: this is of course a memory leak !
  //            Only for demonstration !

  int dsize = 8;
  double *data = new double[dsize];

  for(int i=0; i<dsize; ++i)
    data[i] = (i / 2.) + 3;

  *cpsize = dsize;
  *cpvector = data;
}

// matrix output
void m_out_copy(float **cpmatrix, int *cprows, int *cpcols)
{
  // ATTENTION: this is of course a memory leak !
  //            Only for demonstration !

  int drows = 2;
  int dcols = 3;
  float *data = new float[drows*dcols];

  for(int i=0; i<(drows*dcols); ++i)
    data[i] = (i / 2.) + 1;

  *cprows = drows;
  *cpcols = dcols;
  *cpmatrix = data;
}
