/*
  Interface between numpy arrays and C.
  Build after looking at the umfpack.i interface from scipy SVN.

  This could should be seen as a demonstration and should be
  customized to your application (e.g. there could be more error
  checking etc.).

  More detailed information:
  - tutorial to start:
    http://www.geocities.com/foetsch/python/extending_python.htm
  - numpy c api: http://numpy.scipy.org/numpydoc/numpy-13.html
  - swig and python: http://www.swig.org/Doc1.3/Python.html
  - swig and numpy: http://www.scipy.org/Cookbook/SWIG_and_NumPy
*/

%module example

%include numpy2carray.i

%{
extern void v_in( double *vector, int size );
extern void m_in( double *matrix, int rows, int cols );
extern void v_out( double **aout, int *size );
extern void m_out( float **matrix, int *rows, int *cols );
extern void v_out_copy( double **cpvector, int *cpsize );
extern void m_out_copy(float **cpmatrix, int *cprows, int *cpcols);
%}


/******************************************************************/
// define C array to numpy converters

ARRAY1_IN( double, double, DOUBLE )
%apply (double *array, int size) {(double *vector, int size)};

ARRAY2_IN( double, double, DOUBLE )
%apply (double *array, int rows, int cols)
{(double *matrix, int rows, int cols)};


ARRAY1_OUT( double*, DOUBLE )
%apply (double ** array, int *size)
{ (double **aout, int *size) };

ARRAY2_OUT( float*, FLOAT )
%apply (float ** array, int *rows, int *cols)
{ (float **matrix, int *rows, int *cols) };


ARRAY1_OUT_COPY( double*, DOUBLE )
%apply (double ** cparray, int *cpsize)
{ (double **cpvector, int *cpsize) };

ARRAY2_OUT_COPY( float*, FLOAT )
%apply (float ** cparray, int *cprows, int *cpcols)
{ (float **cpmatrix, int *cprows, int *cpcols) };


/******************************************************************/
// source

%include "example.cpp"
